DECLARE EXTERNAL FUNCTION CREATELIST
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'CREATEIBLIST' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION DELETELIST
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'DELETEIBLIST' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION LISTADD
    INTEGER,
    VARCHAR(1024) BY DESCRIPTOR
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTADD' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION LISTCLEAR
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTCLEAR' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION LISTDELETE
    INTEGER,
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTDELETE' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION LISTEXCHANGE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTEXCHANGE' MODULE_NAME 'ListUdf';


DECLARE EXTERNAL FUNCTION LISTFIND
    INTEGER,
    VARCHAR(1024) BY DESCRIPTOR
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTFIND' MODULE_NAME 'ListUdf';

/* -- This is the declaration for listget for pre-Firebird 2.1.
   -- listget(listId,itemNo,argument) puts value of itemNo to
   -- argument. This won't work in Firebird 2.1 and on. Use
   -- the definition if you need old behaviour.
DECLARE EXTERNAL FUNCTION LISTGET
    INTEGER,
    INTEGER,
    VARCHAR(100) BY DESCRIPTOR
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTGET' MODULE_NAME 'ListUdf';
*/

DECLARE EXTERNAL FUNCTION LISTGET
    INTEGER,   -- listId
    INTEGER,   -- itemNo (zero bazed)
    VARCHAR(1024) BY DESCRIPTOR -- do not pass it
    RETURNS PARAMETER 3  -- null if listId or itemNo are incorrect
    ENTRY_POINT 'IBLISTGETN' MODULE_NAME 'ListUdf';

DECLARE EXTERNAL FUNCTION LISTINSERT
    INTEGER,
    INTEGER,
    VARCHAR(1024) BY DESCRIPTOR
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTINSERT' MODULE_NAME 'ListUdf';

DECLARE EXTERNAL FUNCTION LISTSET
    INTEGER,
    INTEGER,
    VARCHAR(1024) BY DESCRIPTOR
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTSET' MODULE_NAME 'ListUdf';

DECLARE EXTERNAL FUNCTION LISTCOUNT
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTCOUNT' MODULE_NAME 'ListUdf';

DECLARE EXTERNAL FUNCTION LISTSORT
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IBLISTSORT' MODULE_NAME 'ListUdf';

commit;

set term ^ ;

/* returns data set of all list items.
Note: if list size is reduced during call, nulls
can be returned on non-existing indices.
 */
CREATE or ALTER PROCEDURE LIST_ITEMS(list_id int)
  returns (item_value varchar(1024),item_id int)
as
  declare variable cnt int;
begin
cnt=listcount(list_id);
if (cnt<0) then
  begin
  item_id=cnt;
  suspend;
  exit;
  end
item_id=0;
while (item_id<cnt) do
  begin
  item_value=listget(list_id,item_id);
  suspend;
  item_id=item_id+1;
  end
end^

set term ; ^
